---
title: Clipboard API
slug: Web/API/Clipboard_API
tags:
  - API
  - Async Clipboard API
  - Clipboard
  - Clipboard API
  - Clipboard Event API
  - ClipboardEvent
  - ClipboardItem
  - Cut
  - Landing
  - Reference
  - copy
  - paste
---
<div>{{DefaultAPISidebar("Clipboard API")}}</div>

<p>The <strong>Clipboard API</strong> provides the ability to respond to clipboard commands (cut, copy, and paste) as well as to asynchronously read from and write to the system clipboard. Access to the contents of the clipboard is gated behind the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a>: The <code>clipboard-write</code> permission is granted automatically to pages when they are in the active tab. The <code>clipboard-read</code> permission must be requested, which you can do by trying to read data from the clipboard.</p>

<div class="notecard note">
<p><strong>Note:</strong> This API is <em>not available</em> in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a> (not exposed via {{domxref("WorkerNavigator")}}).</p>
</div>

<p>This API is designed to supersede accessing the clipboard using {{domxref("document.execCommand()")}}.</p>

<h2 id="Accessing_the_clipboard">Accessing the clipboard</h2>

<p>Instead of creating a <code>Clipboard</code> object through instantiation, you access the system clipboard through the {{domxref("Navigator.clipboard")}} global:</p>

<pre class="brush: js notranslate">navigator.clipboard.readText().then(
  clipText =&gt; document.querySelector(".editor").innerText += clipText);</pre>

<p>This snippet fetches the text from the clipboard and appends it to the first element found with the class <code>editor</code>. Since {{domxref("Clipboard.readText", "readText()")}} (and {{domxref("Clipboard.read", "read()")}}, for that matter) returns an empty string if the clipboard isn't text, this code is safe.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("Clipboard")}} {{securecontext_inline}}</dt>
 <dd>Provides an interface for reading and writing text and data to or from the system clipboard. The specification refers to this as the 'Async Clipboard API.'</dd>
 <dt>{{domxref("ClipboardEvent")}} {{securecontext_inline}}</dt>
 <dd>Represents events providing information related to modification of the clipboard, that is {{domxref("Element/cut_event", "cut")}}, {{domxref("Element/copy_event", "copy")}}, and {{domxref("Element/paste_event", "paste")}} events. The specification refers to this as the 'Clipboard Event API'.</dd>
 <dt>{{domxref("ClipboardItem")}} {{securecontext_inline}}</dt>
 <dd>Represents a single item format, used when reading or writing data.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Clipboard">Clipboard</h3>

<p>{{Compat("api.Clipboard")}}</p>

<h3 id="ClipboardEvent">ClipboardEvent</h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.ClipboardEvent")}}</p>

<h3 id="ClipboardItem">ClipboardItem</h3>

<p>{{Compat("api.ClipboardItem")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://async-clipboard-api.glitch.me/">Async Clipboard API demo on Glitch</a></li>
 <li><a href="https://web.dev/image-support-for-async-clipboard/">Image support for Async Clipboard article</a></li>
 <li><a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a></li>
 <li><a href="/en-US/docs/Web/API/Permissions_API/Using_the_Permissions_API">Using the Permissions API</a></li>
</ul>
